package net.nevet5gi.buzzbot;

import net.dv8tion.jda.api.JDA;
import net.dv8tion.jda.api.JDABuilder;
import net.dv8tion.jda.api.entities.Activity;
import net.dv8tion.jda.api.utils.cache.CacheFlag;
import net.nevet5gi.buzzbot.commands.utils.CommandManager;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.security.auth.login.LoginException;
import java.util.EnumSet;

public class Bot {
    public static JDA jda;
    private static final Logger LOGGER = LoggerFactory.getLogger(Bot.class);

    public static void main(String[] args) {
        Config.loadConfig();

        try {
            jda = JDABuilder.createDefault(Config.getConfig().getString("bot.token"))
                    .disableCache(EnumSet.of(
                            CacheFlag.CLIENT_STATUS,
                            CacheFlag.ACTIVITY,
                            CacheFlag.EMOTE
                    ))
                    .enableCache(CacheFlag.VOICE_STATE)
                    .addEventListeners(new Listener())
                    .build();
            CommandManager.registerSlashCommands();
            getActivity();
        } catch (LoginException e) {
            e.printStackTrace();
        }

        Listener.startProfanityFilter();
    }

    public static void getActivity() {
        if (Config.getConfig().getString("bot.activity").equalsIgnoreCase("playing")) {
            jda.getPresence().setActivity(Activity.playing(Config.getConfig().getString("bot.action")));
        } else if (Config.getConfig().getString("bot.activity").equalsIgnoreCase("watching")) {
            jda.getPresence().setActivity(Activity.watching(Config.getConfig().getString("bot.action")));
        } else if (Config.getConfig().getString("bot.activity").equalsIgnoreCase("competing")) {
            jda.getPresence().setActivity(Activity.competing(Config.getConfig().getString("bot.action")));
        } else if (Config.getConfig().getString("bot.activity").equalsIgnoreCase("listening")) {
            jda.getPresence().setActivity(Activity.listening(Config.getConfig().getString("bot.action")));
        } else if (Config.getConfig().getString("bot.activity").equalsIgnoreCase("debug")) {
            jda.getPresence().setActivity(Activity.listening("my prefix " + Config.getConfig().getString("bot.prefix")));
        } else {
            jda.getPresence().setActivity(Activity.playing("with myself!"));
        }
    }
}

