package net.nevet5gi.buzzbot;

import net.dv8tion.jda.api.JDA;
import net.dv8tion.jda.api.JDABuilder;
import net.dv8tion.jda.api.utils.cache.CacheFlag;
import net.nevet5gi.buzzbot.database.SqlDB;
import net.nevet5gi.buzzbot.objects.BanData;
import net.nevet5gi.buzzbot.objects.GuildData;

import javax.security.auth.login.LoginException;
import java.sql.Date;
import java.sql.Time;
import java.time.LocalDate;
import java.time.LocalTime;
import java.util.EnumSet;

public class Test {
    private static JDA jda;
    public static void main(String[] args) {
        Config.loadConfig();

        SqlDB sql = new SqlDB();
        GuildData guild = new GuildData();

        guild.setName("DevHQ");
        guild.setId(824071914673668138L);
        guild.setGroup("developer");
        guild.setProfanityLevel(3);

        sql.addGuild(guild);

        //sqlTest();
    }

    private static void initJda() {
        try {
            jda = JDABuilder.createDefault(Config.getConfig().getString("bot.token"))
                    .disableCache(EnumSet.of(
                            CacheFlag.CLIENT_STATUS,
                            CacheFlag.ACTIVITY,
                            CacheFlag.EMOTE
                    ))
                    .enableCache(CacheFlag.VOICE_STATE)
                    .addEventListeners(new Listener())
                    .build();
        } catch (LoginException e) {
            e.printStackTrace();
            jda = null;
        }
    }

    private static void sqlTest() {
        SqlDB db = new SqlDB();
        BanData ban = new BanData(972924565361695745L, "nevetS", 3866, Date.valueOf(LocalDate.now()), Time.valueOf(LocalTime.now()), true, 0, "Reason", "test3", 865368792980914186L, "DevHQ", 824071914673668138L);
        db.insertBan(ban, "masterbanlist");

        SqlDB db2 = new SqlDB();
        BanData qban = db2.queryBan(972924565361695745L, "masterbanlist");

        System.out.println(qban.getUserName());
        System.out.println(qban.getDate());
        System.out.println(qban.getBanReason());
    }
}
